#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import importlib.util
import os
import sys

from recommonmark.parser import CommonMarkParser
from recommonmark.transform import AutoStructify

# KiLuigi documentation build configuration file, created by
# sphinx-quickstart on Tue Dec 19 21:33:10 2017.
#
# This file is execfile()d with the current directory set to its
# containing dir.
#
# Note that not all possible configuration values are present in this
# autogenerated file.
#
# All configuration values have a default; values that are commented out
# serve to show the default.

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.

# Include the directory containing KiLuigi

sys.path.insert(0, os.path.abspath(".."))
sys.path.insert(0, os.path.abspath("../.."))


from kiluigi.utils import MockConfig  # NOQA: E402

# -- General configuration ------------------------------------------------

# If your documentation needs a minimal Sphinx version, state it here.
#
# needs_sphinx = '1.0'

# Add any Sphinx extension module names here, as strings. They can be
# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
# ones.
extensions = [
    "sphinx.ext.autodoc",
    "sphinx.ext.doctest",
    "sphinx.ext.imgmath",
    "sphinx.ext.graphviz",
    "sphinx.ext.inheritance_diagram",
    "kiluigi.docs.pipeline_diagram",
    "sphinx.ext.napoleon",  # only needed if we go for Google or Numpy docstring formats
]

# Add any paths that contain templates here, relative to this directory.
templates_path = ["_templates"]

# Parse Markdown files
source_parsers = {".md": CommonMarkParser}

# The suffix(es) of source filenames.
# You can specify multiple suffix as a list of string:
source_suffix = [".rst", ".md"]

# The master toctree document.
master_doc = "contents"

# General information about the project.

# The KiLuigi library that this documentation is part of will normally
# be included (e.g. using git submodule) in the root folder of a specific
# project. In order to standardize documentation across projects we compile
# the documentation from this common conf.py but allow those projects to
# customize specific documentation aspects, e.g. the project name.

# Read the project name from the first line of the outer README.md file,
# if it exists
try:
    with open(os.path.abspath("../../README.md")) as f:
        # read the first line, removing any Markdown headers or trailing whitespace
        project = f.readline().lstrip("# ").rstrip()
        if not project:
            raise ValueError
        project_description = "Luigi-driven pipelines for {}".format(project)

except Exception:
    # Use a default if we can't find a project name
    project = "Data Pipelines"
    project_description = "Data analysis pipelines using Luigi"

copyright = "2017, Kimetrica llc"  # NOQA
author = "Kimetrica llc"

# Allow overrides through a project-specific docs/conf.py
try:
    # see https://docs.python.org/3/library/importlib.html#importing-a-source-file-directly  # NOQA: E501
    spec = importlib.util.spec_from_file_location(
        "project_conf", os.path.abspath("../../docs/conf.py")
    )
    project_conf = importlib.util.module_from_spec(spec)
    spec.loader.exec_module(project_conf)
    project = getattr(project_conf, "project", project)
    project_description = getattr(
        project_conf, "project_description", project_description
    )
    copyright = getattr(project_conf, "copyright", copyright)
    author = getattr(project_conf, "author", project)
except (FileNotFoundError, ImportError):
    pass

# The version info for the project you're documenting, acts as replacement for
# |version| and |release|, also used in various other places throughout the
# built documents.
#
# The short X.Y version.
version = "0.1"
# The full version, including alpha/beta/rc tags.
release = "0.1"

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#
# This is also used if you do content translation via gettext catalogs.
# Usually you set "language" from the command line for these cases.
language = None

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
# This patterns also effect to html_static_path and html_extra_path
exclude_patterns = ["_build", "Thumbs.db", ".DS_Store"]

# The name of the Pygments (syntax highlighting) style to use.
pygments_style = "sphinx"

# If true, `todo` and `todoList` produce output, else they produce nothing.
todo_include_todos = False


# -- Options for HTML output ----------------------------------------------

# The theme to use for HTML and HTML Help pages.  See the documentation for
# a list of builtin themes.
#
html_theme = "alabaster"

# Theme options are theme-specific and customize the look and feel of a theme
# further.  For a list of options available for each theme, see the
# documentation.
html_theme_options = {"description": project_description}

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
html_static_path = ["_static"]

# Custom sidebar templates, must be a dictionary that maps document names
# to template names.
#
# This is required for the alabaster theme
# refs: http://alabaster.readthedocs.io/en/latest/installation.html#sidebars
html_sidebars = {
    "**": [
        "about.html",
        "navigation.html",
        "relations.html",  # needs 'show_related': True theme option to display
        "searchbox.html",
    ]
}

html_logo = "_static/logo.png"

# -- Options for HTMLHelp output ------------------------------------------

# Output file base name for HTML help builder.
htmlhelp_basename = project.replace(" ", "_") + "_docs"


# -- Options for LaTeX output ---------------------------------------------

latex_elements = {
    # The paper size ('letterpaper' or 'a4paper').
    "papersize": "a4paper",
    # The font size ('10pt', '11pt' or '12pt').
    #
    # 'pointsize': '10pt',
    # Additional stuff for the LaTeX preamble.
    #
    # 'preamble': '',
    # Latex figure (float) alignment
    #
    # 'figure_align': 'htbp',
}

# Grouping the document tree into LaTeX files. List of tuples
# (source start file, target name, title,
#  author, documentclass [howto, manual, or own class]).
latex_documents = [
    (
        master_doc,  # top-level file
        project.replace(" ", "_").lower() + ".tex",  # output
        project,  # document title
        author,  # document author
        "manual",
    )
]

# -- Options for manual page output ---------------------------------------

# One entry per manual page. List of tuples
# (source start file, name, description, authors, manual section).
man_pages = [(master_doc, project, project, [author], 1)]


# -- Options for Texinfo output -------------------------------------------

# Grouping the document tree into Texinfo files. List of tuples
# (source start file, target name, title, author,
#  dir menu entry, description, category)
texinfo_documents = [
    (master_doc, project, project, author, project, project, "Miscellaneous")
]

# Global substituions
rst_epilog = """
.. |ProjectName| replace:: {project}
""".format(
    project=project
)

# Configure inheritance diagrams to be rendered vertically
inheritance_graph_attrs = dict(rankdir="TB", size='"20.0, 20.0"')


def setup(app):
    app.add_config_value(
        "recommonmark_config",
        {"auto_toc_tree_section": False, "graphviz_output_format": "svg"},
        True,
    )
    app.add_transform(AutoStructify)

    MockConfig().apply_patch()
